﻿using ff14bot;
using ff14bot.AClasses;
using ff14bot.Behavior;
using ff14bot.Enums;
using ff14bot.RemoteWindows;
using TreeSharp;

namespace Heathcliff
{
    public class HeathcliffBot : BotBase
    {
        private Composite root;

        public override string Name
        {
            get { return "Heathcliff"; }
        }

        public override PulseFlags PulseFlags
        {
            get { return PulseFlags.All; }
        }

        public override bool RequiresProfile
        {
            get { return false; }
        }

        public override bool IsAutonomous
        {
            get { return false; }
        }

        public override Composite Root
        {
            get { return root ?? (root = CreateRoot()); }
        }

        private static Composite CreateRoot()
        {
            var paladinRoutine = new PaladinRoutine();
            var darkKnightRoutine = new DarkKnightRoutine();

            var routine = Core.Me.CurrentJob == ClassJobType.Paladin ? 
                paladinRoutine.Behavior : darkKnightRoutine.Behavior;

            return new PrioritySelector(routine);
        }

        private static Composite SkipDialog()
        {
            var talk = new Action(r => {Talk.Next(); return RunStatus.Success;});
            return new Decorator(c => Talk.DialogOpen, talk);
        }
    }
}
