﻿using ff14bot;
using ff14bot.Managers;
using ff14bot.Objects;
using TreeSharp;

namespace Heathcliff
{
    internal static class Spells
    {
        public static Composite CastOnTarget(uint spellId)
        {
            return new Action(r => CastTargetSpell(spellId));
        }

        public static Composite CastOnSelf(uint spellId)
        {
            return new Action(r => CastSelfSpell(spellId));
        }

        private static RunStatus CastSelfSpell(uint spellId)
        {
            if (!Actionmanager.CanCast(spellId, Core.Me)) { return RunStatus.Failure; }
            return Actionmanager.DoAction(spellId, Core.Me) ? RunStatus.Failure : RunStatus.Success;
        }

        private static RunStatus CastTargetSpell(uint spellId)
        {
            if (Core.Me.CurrentTarget == null || !Actionmanager.CanCast(spellId, Core.Me.CurrentTarget)) { return RunStatus.Failure; }
            return Actionmanager.DoAction(spellId, Core.Me.CurrentTarget) ? RunStatus.Failure : RunStatus.Success;
        }
    }
}
